/* Documentation of the MEM module.  This file is not compiled. 
 */

/* Wrapper around the malloc() family of functions. 
 */

class Mem
{
public:

	static
	void *Alloc(int size);
	/* Allocate SIZE memory.  SIZE should be a multiple of the
	   value returned by sizeof().  Return NULL if no memory is
	   available.  Return NULL when SIZE is zero.  SIZE cannot be
	   negative.  Allocated memory must be released with Free() or
	   reallocated with Re_Alloc(). 
	 */

	static
	void *Re_Alloc(void *pointer, 
		       int size);
	/* Change the size of allocated memory.  POINTER must have
	   been returned by Alloc() or Re_Alloc().  If POINTER is
	   NULL, Re_Alloc() behaves like Alloc().  The memory block is
	   changed to have size SIZE.  If reallocation fails, the
	   return value is NULL and the memory at POINTER is not
	   touched.  If allocation is successful, the return value is
	   the location of the block, which might be different than
	   POINTER.  Reallocation may fail even when SIZE is smaller
	   than the current size of the memory.  If SIZE is zero
	   Re_Alloc() behaves like Free().  The returned memory must
	   be released with Free() or reallocated with Re_Alloc().  
	 */

	static
	void Free(void *pointer);
	/* Release memory allocated with Alloc() or Re_Alloc().
	   POINTER might be NULL. 
	 */
};
