/* Documentation of the PROCESS module.  This file is not compiled. 
 */

typedef djhfsjlfhkshjdf Process;
/* process descriptor */

#define PROCESS_NO  8203948
/* Value of type Process that is never used for a process. 
 */

bool
Process_Create(String                 program_file_name, 
	       const Vector <String> &args,
	       bool                   wait,
	       Process               *process= NULL,
	       Pointer <Stream>       input= NULL,
	       Pointer <Stream>       output= NULL,
	       Pointer <Stream>       error_output= NULL,
	       bool                   nice= false);

/* Create a new process that executes PROGRAM_FILE_NAME. 

   PROGRAM_FILE_NAME can be an absolute or relative file name.  

   ARGS are the arguments given to the program that is executed.  

   If WAIT is TRUE, the function waits until the process finishes, and does not 
   write anything into PROCESS.  If WAIT is FALSE, the function returns
   immediately and writes the process ID into PROCESS.     

   The return value is TRUE when a process was created.

   If WAIT is TRUE, PROCESS is ignored.  If WAIT is FALSE, PROCESS must not be
   NULL.  If WAIT is FALSE and the process is created, the process ID of the
   newly created process is written into PROCESS.  

   INPUT, OUTPUT and ERROR_OUTPUT contain, if not NULL, the stream that the input,
   output and error output, respectively, are redirected to.  The three open
   streams are not affected in THIS process.  They must be open when
   Process_Create() is called, but can be closed right after the call, even if
   WAIT was FALSE.  

   If NICE, execute child with low priority. 
 */

bool
Process_Wait(Process process,
	     int &exit_code);
/* Wait until PROCESS finishes.  If waiting is successful, the return
   value is TRUE, and EXIT_CODE is written to the exit code of the
   process.  
*/

void 
Process_Kill(Process process);
/* Kill PROCESS. 
 */

bool
Process_Scan(Process &process,
	     String name);
/* Scan NAME as type PROCESS and return TRUE if successful. 
 */

bool
Process_Exists(Process);
/* Whether is running. 
 */

Process
Process_Self();
/* Current process. 
 */

String Process_Format(Process);
/* Format PROCESS. 
 */

/* Child processes are not terminated automatically when the parent
   process terminates. 
 */

void Process_Pause(Process);
void Process_Resume(Process);
bool Process_Paused(Process);

