/* Documentation of the SERVER_IMAGE module.  This file is not compiled. 
 */

/* As server image is stored on the display server.  It can be quickly
   transfered to the screen. 
 */

class Server_Image
{
public:

	bool Is() const;

	Point Get_Size() const;
	/* Image must have been created. */

	bool Create(Point size);
	/* Neither X nor Y of SIZE must be 0.  Return TRUE on success.
	   Must not be allocated. 
	 */

	void Free();
	/* Do nothing if image is not created. 
	 */

	bool Has_Canvas() const;
	/* Whether a canvas could be created.
	 */
	Canvas &Get_Canvas() const;
	/* Has_Canvas() must have returned TRUE. 
	 */
	Canvas &operator () () const;
	/* Alias for Get_Canvas(). 
	 */
//	bool Get_Canvas(Canvas &) const;
	/* Open CANVAS on this image.  CANVAS must be closed.  
	 */
};
