#include "arg.hh"

#include "io.hh"
#include "e_mail.hh"
#include "web_site.hh"
#include "version_number.hh"
#include "write_formatted.hh"

#ifdef NDEBUG
#    define ARG_TEXT
#else
#    define ARG_TEXT    " Debug"
#endif

bool
Arg(int argc, char **argv)
{
	if (argc > 1)
	{
		/* --help */
		if (0 == strcmp(argv[1], "--help"))
		{
			Write_Formatted(IO::out,
				    "\n%s\n"
				    "Meta-options:\n"
				    "\t--help           Print a short help.\n"
				    "\t--version        Print program version number.\n\n"
				    "Send bug reports to <" E_MAIL ">.\n"
				    "Visit the web site: <"
					WEB_SITE ">\n\n",
					arg_get_help);
			return true;
		}

		/* --version */
		else if (0 == strcmp(argv[1], "--version"))
		{
			Write_Formatted(IO::out,
				    "\n"
				    "Version " VERSION_NUMBER
				    ARG_TEXT " (" __DATE__ ")\n\n"); 
			return true;
		}
	}
	return false;
}
