#ifndef ARG_MAIN_INCLUDED
#define ARG_MAIN_INCLUDED

/* Implements Main() and takes care of meta-options.  Calls the
   function Arg_Main() that must be implemented.  
 */

/* If the macro ARG_MAIN_OWN_ARG is defined before including, args are
   not processed. 

   If ARG_MAIN_OWN_ARG is not defined, ARG_GET_HELP must be defined
   for the ARG module. 
 */

extern
int
Arg_Main(int    argc,
	 char **argv);
/* To be defined:

   Function called.  ARGC and ARGV as in main(). 
 */

#if 0

#ifndef ARG_MAIN_NO_DEF
#   ifdef ARG_MAIN_OWN_ARG
bool arg_main_own_arg= true;
#   else
bool arg_main_own_arg= false;
#   endif
#else
extern bool arg_main_own_arg;
#endif

#endif /* 0 */ 


#endif /* ! ARG_MAIN_INCLUDED */
