#ifndef BOARD_SETTINGS_INCLUDED
#define BOARD_SETTINGS_INCLUDED

#include "rgb.hh"
#include "pointer.hh"

enum
{bs_turned=     (1 << 0),
 bs_frame=      (1 << 1),
 bs_show_names= (1 << 2),
 bs_anti_alias= (1 << 3)};

class Board_Settings
	:  virtual public Pointed
{
public:

	enum {color_count= 4};

	int flags;

	RGB colors[color_count];
	/* index:  0:  white
	 *         1:  black
	 *         2:  last move
	 *         3:  frame
	 */

	void Reset();

	static const char *Get_RC_Name()
		{
			return "board_settings"; 
		}
};

#endif /* ! BOARD_SETTINGS_INCLUDED */
