#ifndef BUSY_INCLUDED
#define BUSY_INCLUDED

#include "color_display.hh"
#include "timer.hh"

class Busy
	:  public Color_Display,
	   public Timer
{
public:

	bool Open(Pointer <Widget> parent)
		{
			count= 0;
			return Color_Display::Open(parent, RGB(0xff, 0xff, 0xff));
		}

	void Start();
	void Stop();
	void Set(bool active)
		{
			if (active)
				Start();
			else
				Stop();
		}

	bool Is() const
		{
			return Color_Display::Is(); 
		}
private:

	int count;

	void Wdg_Close();

	void Timer_Alarm();

};

#endif /* ! BUSY_INCLUDED */
