#ifndef CHILD_PROCESS_INCLUDED
#define CHILD_PROCESS_INCLUDED

#include "process.hh"
#include "process_usage.hh"

class Child_Process
{
public:

	Child_Process();
	~Child_Process();
	/* Killed on destruction. 
	 */

	bool Is() const;

	bool Open(String program_file_name,
		  const Vector <String> &args,
		  Stream *in,
		  Stream *out,
		  Stream *err,
		  bool nice= false);
	/* Must not be. */

	void Close();
	/* Must be open. */

	int Wait();
	/* Must be open.  Wait for completion and return exit code. 
	 */

	void Pause();
	/* If running pause, if pausing resume. 
	 */
	bool Paused() const
		{
			Assert (Is());
			return paused;
		}

	Process_Usage Get_Process_Usage() const
		{
			Assert (Is());
			return ::Get_Process_Usage(child);
		}
	Process Get_Process() const
	  {
	    Assert (Is());
	    return child; 
	  }

private:

	Process child;
	/* = PROCESS_NO when closed. 
	 */
	bool paused;
};

#endif /* ! CHILD_PROCESS_INCLUDED */
