#include "choice_editor.hh"

bool Choice_Editor::Editor_Window_Open(Pointer <Packer> parent)
{
	Get_Window().Set_Caption(choice.title); 
	page.Open(parent(), choice.text); 
	bevel.Open(parent());
	if (button_bar.Open(parent()))
		for (int i= 0;  i < ch_count;  ++i)
		{
			if (choice.choices & (1 << i))
			{
				button_bar.Append
					(Editor_Window <Choice> ::msg_custom + i,
					 Trl(choice_text[i])); 
			}
		}
	return true; 
}

void Choice_Editor::Editor_Window_Set_Value(Pointer <const Choice> value)
{
	Assert (value.Is()); 
	choice= value(); 
}

void Choice_Editor::MR_Receive(int msg)
{
	if (msg >= Editor_Window <Choice> ::msg_custom     &&
	    msg <  Editor_Window <Choice> ::msg_custom + ch_count)
	{
		int new_choice= (1 << (msg - Editor_Window <Choice> ::msg_custom)); 
		Assert (choice.choices & new_choice); 
		choice.selection= new_choice; 
		Editor_Window <Choice> ::MR_Receive
			(msg_ok); 
	}
	else
	{
		Editor_Window <Choice> ::MR_Receive(msg); 
	}
}
Point Choice_Editor::Wdg_Get_Window_Size() const
{
	return Point(-1);
}
