#ifndef CONTAINING_INCLUDED
#define CONTAINING_INCLUDED

//#include "single_parent_widget.hh"
#include "widget.hh"

template <class Container, // t
	class Contained>  // u
class Containing  
	:  /* virtual public Single_Parent_Widget, */ 
	   public Container
{
public:

	class Open_Info
	{
	public:

		Open_Info() {}
		Open_Info(typename Container::Open_Info oi): t_open_info(oi) {}
		Open_Info(typename Contained::Open_Info oi): u_open_info(oi) {}
		Open_Info(typename Container::Open_Info ti,
			  typename Contained::Open_Info ui)
			:  t_open_info(ti), u_open_info(ui)
			{}

		typename Container::Open_Info t_open_info;
		typename Contained::Open_Info u_open_info;
	};

	bool Open(Pointer <Widget> parent)
		{
			if (! Container::Open(parent))
				return false;

			if (! u.Open(this))
			{
				Container::Close();
				return false;
			}
			return true;
		}

	bool Open(Pointer <Widget> parent, 
		  typename Contained::Open_Info ui)
		{
			if (! Container::Open(parent))
				return false;
			if (! u.Open(this, ui))
			{
				Container::Close();
				return false;
			}
			return true;
		}

	bool Open(Pointer <Widget> parent,
		  typename Container::Open_Info ti, 
		  typename Contained::Open_Info ui)
		{
			if (! Container::Open(parent, ti))
				return false;
			if (! u.Open(this, ui))
			{
				Container::Close();
				return false;
			}
			return true;
		}

	bool Open(Pointer <Widget> parent,
		  typename Container::Open_Info ti)
		{
			if (! Container::Open(parent, ti))
				return false;
			if (! u.Open(this))
			{
				Container::Close();
				return false;
			}
			return true;
		}

	bool Open(Pointer <Widget> parent,
		  typename Containing <Container, Contained> ::Open_Info oi);

	Contained &operator () () 
		{
			return u; 
		}

	const Contained &operator () () const
		{
			return u; 
		}
private:

	Contained u;

	void Wdg_Append_Child(Widget &widget)
		{
			Container::Wdg_Append_Child(widget); 
		}
};

template <class Type_Containing, class Type_Contained>
bool Containing <Type_Containing, Type_Contained> ::Open(Pointer <Widget> parent,
		  typename Containing <Type_Containing, Type_Contained> ::Open_Info oi)
		{
			if (! Type_Containing::Open(parent, oi.t_open_info))
				return false;
			if (! u.Open(this, oi.u_open_info))
			{
				Type_Containing::Close();
				return false;
			}
			return true;
		}

#endif /* ! CONTAINING_INCLUDED */
