#include "default_timer.hh"

#include "deref.hh"
#include "date.hh"

Vector <Pointer <Timer> > timer_list;

#if 0
Timer::Timer()
	:  index (-1)
{
}
#endif /* 0 */

bool 
Timer::Start(int new_interval)
{
	Assert (! Is());

	if (! content.Alloc())
		return false;

	for (int i= 0;  i < *timer_list && content().index == -1;  ++i)
		if (timer_list[i] == NULL)
		{
			content().index= i;
		}

	if (! timer_list.Set(*timer_list + 1))
		return false;
	content().index= *timer_list - 1; 
	
	timer_list[content().index]= this;

	content().interval= new_interval;
	content().last_alarm= Get_Date();

	return true;
}

void
Timer::Stop()
{
	if (! Is())
		return; 

//	Vector <Pointer <Timer> > &li= list;

//	(void) li;

	timer_list[content().index]= NULL;
//	contentindex= -1;
	int new_size= *timer_list;
	while (new_size != 0 && timer_list[new_size - 1] == NULL)
		-- new_size;
	timer_list= new_size; 

	content.Free();
}

#if 0
int
Timer::Get_Interval() 
     const
{
	Assert (Is());
	return interval;
}
#endif /* 0 */ 

#if 0
void
Timer::Call()
{
	last_alarm= Get_Date();
	Timer_Alarm();
}
#endif /* 0 */ 

Timer::~Timer() 
{
	Assert (! Is()); 
}

Timer::Timer()
{
}
