#ifndef DEFAULT_TIMER_INCLUDED
#define DEFAULT_TIMER_INCLUDED

#include "vector.hh"
#include "pointer.hh"
#include "timer.hh"

class Timer_Content
{
public:

	int index;
	/* index in LIST. 
	 */
	int interval; /* ms */
	Date last_alarm;
};

extern Vector <Pointer <Timer> > timer_list;

#if 0

#include "pointer.hh"
#include "vector.hh"
#include "date.hh"

class Timer
	:  virtual public Pointed
{
public:

	Timer();
	virtual ~Timer(); 

	bool Start(int interval_ms);
	void Stop();
	bool Is() const 
		{
			return index != -1;
		}
	int Get_Interval() const; /* ms */
	void Call();
	Date Get_Last_Alarm() const
		{
			Assert(Is());  
			return last_alarm; 
		}

	virtual void Timer_Alarm()= 0;
	/* Timer_Alarm() may call Stop(). 
	 */

	/* The list doesn't change even when Stop() is called.  The
	   list contains NULL. 
	 */
	static Vector <Pointer <Timer> > &Get_List() 
		{
			return list;
		}

private:

	int index;
	/* -1 if closed, else index in LIST. 
	 */
	int interval; /* ms */
	Date last_alarm;

	static Vector <Pointer <Timer> > list;
	/* Elements may be NULL. 
	 */
};

#endif /* 0 */ 

#endif /* ! DEFAULT_TIMER_INCLUDED */
