#ifndef ERROR_INCLUDED
#define ERROR_INCLUDED

/* Per-process error value.  Set by many functions, including those 
   that return `bool'.
 */

#include "string.hh"

#include <errno.h>

class Error
{
public:

	static int Get_Code()
		{
			return errno == -1 ? EINVAL : errno;
		}
	/* One of the constants beginning with `E'. 
	 */
	
	static String Get();
	/* Text message.  Not terminated by a period. 
	 */

	static void Set(int code)
		{
			errno= code;
		}
	static void Set(String error);
	/* Not terminated by a period.  
	 */
	static void Set_No_Sys()
		{
			Set(ENOSYS);
		}
	static String Get_File_Name()
		{
			return file_name; 
		}
	static void Set_File_Name(String new_file_name)
		{
			file_name= new_file_name; 
		}

private:

	static String string; 
	/* The error message.  Used when ERRNO is -1.  Not terminated
	   by a period. 
	 */
	static String file_name; 
};

#endif /* ! ERROR_INCLUDED */
