#include "evaluator_settings_editor.hh"

bool
Evaluator_Settings_Editor::Object_Editor_Open(Pointer <Widget> parent)
{
	if (! chooser.Open(parent,
			   -1,
			   Trl("Timing"),
			   2))
		return false;
	chooser.Append(Trl("Infinite"));
	chooser.Append(Trl("Time"));
	chooser.Set_Selected(settings.timing);

	if (! time_packer.Open(parent))
		return false;
	if (! time_label.Open(time_packer, Format("%s:", Trl("Time"))))
		return false;
	time_packer.Set_Next_Resizeable(true);
	if (! time_s.Open(time_packer,
			  Int_Edit::Open_Info(msg_ignore,
					      settings.time_s,
					      1)))
		return false;
	if (! time_unit.Open(time_packer, "s"))
		return false;

	if (! nice_check_box.Open(parent,
				  settings.nice,
				  Trl("Run with low priority")))
		return false; 
	if (! auto_reply_check_box.Open(parent,
					settings.auto_reply,
					Trl("Auto reply")))
		return false;

	return true; 
}


void Evaluator_Settings_Editor::Make_Result()
{
	settings.timing= (Evaluator_Settings::Timing)chooser.Get_Selected();
	if (settings.timing == -1)
		settings.timing= Evaluator_Settings::ti_infinite;
	settings.time_s= time_s.Get_Value();
	settings.nice= nice_check_box.Get_Checked(); 
	settings.auto_reply= auto_reply_check_box.Get_Checked();
}

const Evaluator_Settings &Evaluator_Settings_Editor::Editor_Window_Get_Value()
{
	if (Is())
		Make_Result(); 
	return settings;
}
