#include "file_dialog.hh"

#include "trl.hh"
#include "dbg.hh"

void File_Dialog::Open(bool new_load,
		       int new_msg_edited,  
		       Widget &new_owner,
		       String file_name)
{
	Dbg_Function(); 

	if (widget != NULL)
	{
		Dbg("\talready open.");

		return;
	}

	load= new_load;
	msg_edited= new_msg_edited; 
	owner= new_owner; 

	widget= gtk_file_selection_new
		(load ? Trl("Load file") : ("Save file"));

	if (widget == NULL)
	{
		Dbg("\twidget= NULL;");
		return;
	}

	Dbg("\tsuccess.");

	gtk_window_set_transient_for(GTK_WINDOW(widget),
				     GTK_WINDOW(new_owner.Get_Window().Get())); 
	
	gtk_file_selection_set_filename(GTK_FILE_SELECTION(widget),
					 file_name());

                           
	gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION(widget)->ok_button),
				   "clicked", GTK_SIGNAL_FUNC(& Signal_OK),
			    this);

	gtk_signal_connect
		(GTK_OBJECT (GTK_FILE_SELECTION(widget)->cancel_button),
		 "clicked", GTK_SIGNAL_FUNC(& Signal_Cancel),
		 this);

	gtk_widget_show(widget); 
}

void File_Dialog::Close()
{
	if (widget == NULL)
		return; 

	file_name= gtk_file_selection_get_filename
		(GTK_FILE_SELECTION(widget));

	gtk_object_destroy(GTK_OBJECT(widget));

	widget= NULL;
}

void File_Dialog::Signal_OK(GtkWidget *, gpointer data)
{
	Dbg_Function();
	File_Dialog &fd= Deref((File_Dialog *)data);
	fd.Close();
	fd.owner().MR_Send(fd.msg_edited); 
}

void File_Dialog::Signal_Cancel(GtkWidget *, gpointer data)
{
	Dbg_Function();
	File_Dialog &fd= Deref((File_Dialog *)data);
	fd.Close();
}


