#ifndef FILE_DIALOG_INCLUDED
#define FILE_DIALOG_INCLUDED

#include "widget.hh"

#include <gtk/gtk.h>

class File_Dialog
{
public:

	File_Dialog()
		:  widget(NULL)
		{
		}
	~File_Dialog()
		{
			Assert (widget == NULL); 
		}

	void Open(bool /* load */ ,       
		  int /* msg_edited */ ,  
		  Widget & /* owner */ ,
		  String /* file_name */ = "");

	void Close();

	bool Get_Load() const
		{
			return load;
		}

	String Get_Value()
		{
			if (widget == NULL)
				return file_name;
			else
				return gtk_file_selection_get_filename
					(GTK_FILE_SELECTION(widget));
		}

	bool Have_Read()
		{
//			Close();
			return true; 
		}

private:

	GtkWidget *widget;
	bool load;
	String file_name;
	/* Valid when closed.  If open, the file name is read from the
	   widget. 
	 */
	int msg_edited;
	Pointer <Widget> owner;

	static void Signal_OK(GtkWidget *, gpointer);
	static void Signal_Cancel(GtkWidget *, gpointer);
};

#endif /* ! FILE_DIALOG_INCLUDED */
