#ifndef FILE_NAME_INCLUDED
#define FILE_NAME_INCLUDED

/* Operations on file names.
 */

#include "inline.hh"
#include "string.hh"

Inline
String
Root_Dir()
{
	return '/';
}

String
Base_Name(String file_name);
/* The name of the file whose absolute file name is FILE_NAME.  Return
   the empty string if FILE_NAME is NULL. 
*/

String
Path_Name(String _name);
/* Path equivalent to BASE_NAME. 
 */

String
File_Name_In_Dir(String directory_name, 
		 String file_name);
/* Return the name of the file named FILE_NAME in directory
   DIRECTORY_NAME.  If DIRECTORY_NAME is empty, return FILE_NAME.  If
   FILE_NAME is absolute, return FILE_NAME. 
*/

Inline
String
operator / (String d, String f)
{
	return File_Name_In_Dir(d, f);
}

String Sub_Dir(int n);
/* The subdirectory of level N.  For instance, Sub_Dir(3) is
   "../../..".  N must be greater or equal than zero. 
 */

Inline
bool Is_Ordered_File(String _name)
{
	return _name != '.' && _name != "..";
}

#endif /* ! FILE_NAME_INCLUDED */
