#include "format.hh"

#ifdef FORMAT_OLD_IMPLEMENTATION

#include "assert.hh"

#include <stdarg.h>
#include <stdio.h>

#define FORMAT_LEN 0x80

String
Format(const char *format, 
       ...)
{
	Assert (format != NULL);

	va_list vl;

	va_start(vl, format);

	char buf[FORMAT_LEN];

	vsnprintf(buf,
		  FORMAT_LEN,
		  format,
		  vl);

	/* Can vsnprintf() be called several times?  If yes, add code to
	   retry with bigger FORMAT_LEN on failure. 
	*/

	va_end(vl);

	return buf;
}

#endif /* FORMAT_OLD_IMPLEMENTATION */
