#include "format_sec.hh"

#include "text_utils.hh"
#include "format.hh"
#include "trl.hh"

String
Format_Sec(int seconds,
	   bool show_milliseconds,
	   int milliseconds)
{
	Assert (seconds >= 0);

	String result;
	String unit;

	int min= seconds / 60;
	if (min != 0)
	{
		int hr= min / 60;
		if (hr != 0)
		{
			unit= Trl(" h");
			int day= hr / 24;
			if (day != 0)
			{
				result += Format("%d", day);
				result += Trl(" days ");
			}
			result += Format("%d", hr % 24);
			result += ':';
			result += (char)('0' + min % 60 / 10);
			result += (char)('0' + min % 10);
		}
		else
		{
			unit= Trl(" min");
			result += Format("%d", min % 60);
		}
		result += (char)':';
		result += (char)('0' + seconds % 60 / 10);
		result += (char)('0' + seconds % 10);
	}
	else
	{
		unit= Trl(" s");
		result += Format("%d", seconds % 60);
	}

	if (show_milliseconds > 0)
	{
		Assert (milliseconds >= 0 && milliseconds < 1000); 
		result += Format(".%c%c%c",
				 (char)('0' + milliseconds / 100),
				 (char)('0' + milliseconds / 10 % 10),
				 (char)('0' + milliseconds % 10)); 
	}

	result += unit;

	return result;
}

