#ifndef FRAME_INCLUDED
#define FRAME_INCLUDED

#include "widget.hh"
#include "frame_type.hh"
#include "dbg.hh"

class Frame
	:  /*virtual*/ public Widget
{
public:

	struct Open_Info
	{
		Frame_Type frame_type;
		String text;

		Open_Info(Frame_Type new_frame_type= ft_default,
			  String new_text= "")
			:  frame_type (new_frame_type),
			   text(new_text)
			{
			}
	};

	bool Open(Pointer <Widget> parent)
		{
			return Open(parent, Open_Info());
		}
	bool Open(Pointer <Widget> parent,
		  Open_Info open_info);

	void Wdg_Append_Child(Widget &widget)
		{
			gtk_container_add(GTK_CONTAINER(Get()),
					  widget.Get()); 
		}
	void Set_Text(String text) 
		{
			gtk_frame_set_label(GTK_FRAME(Get()),
					    text());
		}
};

#endif /* ! FRAME_INCLUDED */ 
