#ifndef GAME_ARCHIVE_EDITOR_INCLUDED
#define GAME_ARCHIVE_EDITOR_INCLUDED

#include "document_editor.hh"
#include "game_archive.hh"
#include "game_archive_stream.hh"
#include "status_bar.hh"
#include "game_editor.hh"

class Game_Archive_Editor
	:  public Document_Editor <Game_Archive> 
{
public:

	static const char * Get_Help()
		{
			return "Open a chess game archive.\n";
		}
private:

	enum {menu_edit= Document_Editor <Game_Archive>
		::menu_custom, 

		msg_insert= Document_Editor <Game_Archive> ::msg_custom,
	      msg_remove, msg_edit, msg_list_clicked,
	      
	      msg_edited}; 
	      

	class Edited_Game
	{
	public:

		int game_index;
		Owned_Editor <Game_Editor> game_editor;
	};

	Multi_List_Box game_list;
	H_Button_Bar button_bar;
	Status_Bar status_bar;

	Game_Archive game_archive;
	Vector <Edited_Game> edited_games;

	bool Document_Editor_Open(Pointer <Packer>);

	const char *EW_Type_Name() const 
		{
			return Trl("Chess Game Archive");
		}
	const char *EW_Short_Type_Name() const
		{
			return Trl("Archive"); 
		}

	void Editor_Window_Set_Value(Pointer <const Game_Archive>);
	const Game_Archive &Editor_Window_Get_Value();
	bool Editor_Window_Change_Value(const Game_Archive &);
	void DE_New();

	void Menued_Get(int menu, Menued::Entries &entries);

	void MR_Receive(int);

	void Wdg_Close();

	void Update_List();
	void Update_Count();
	void Close_Editors();
	void Edit(int index= -1,
		  bool set_selection= true);
	/* Edit game INDEX.  If -1, use selection of list box. 
	 */
	void Update_Game_Info(int game_index);
};

#endif /* ! GAME_ARCHIVE_EDITOR_INCLUDED */






