#ifndef GAME_INFO_INCLUDED
#define GAME_INFO_INCLUDED

#include "hash_table.hh"

class Game_Info
	:  public Pointed
{
public:
	
	enum Result {re_white= 0, re_draw, re_black, re_unfinished}; 

	String event, site, date, round, white, black; 
	Result result; 
	/* The result is independent from the game moves. 
	 */

	Hash_Table tags;
	/* Additional tags. 
	 */

	/* The FEN tag is not part of Game_Info.  It is part of the
	   game. 
	*/

	void Reset();

	void Set(const Hash_Table &all_tags);
	/* ALL_TAGS contains all tags, including those that
	   are stored as a string and Result in Game_Info.
	   Ignore "FEN" and "SetUp" tags. 
	*/

	static String Get_Result_Text(Result result)
		{
			Assert (result >= 0 && result <= 3);
			return result_text[result]; 
		}
	String Get_Result_Text() const
		{
			return Get_Result_Text(result); 
		}

private:

	static const char *result_text[4];
};

#endif /* ! GAME_INFO_INCLUDED */ 
