#include "game_info_editor.hh"

#include "trl.hh"

void
Game_Info_Editor::Editor_Window_Set_Value(Pointer <const Game_Info> new_game_info)
{
	if (new_game_info.Is())
	{
		game_info= new_game_info(); 
	}
	else
		game_info.Reset(); 
}

bool
Game_Info_Editor::Object_Editor_Open(Pointer <Widget> parent)
{
	if (! packer.Open(parent, 2))
		return false; 
	
	if (! (texts[0].Open(packer, "Event:")         &&
	       edits[0].Open(packer, game_info.event)  &&
	       texts[1].Open(packer, "Site:")          &&
	       edits[1].Open(packer, game_info.site)   &&
	       texts[2].Open(packer, "Date:")          &&
	       edits[2].Open(packer, game_info.date)   && 
	       texts[3].Open(packer, "Round:")         &&
	       edits[3].Open(packer, game_info.round)  &&
	       texts[4].Open(packer, "White:")         &&
	       edits[4].Open(packer, game_info.white)  &&
	       texts[5].Open(packer, "Black:")         &&
	       edits[5].Open(packer, game_info.black)))
		return false; 

	if (! chooser.Open(parent, -1, Trl("Game outcome"), 4))
		return false;

	if (! (chooser.Append("White win")   &&
	       chooser.Append("Draw")        &&
	       chooser.Append("Black win")   &&
	       chooser.Append("Unfinished")))
		return false; 

	chooser.Set_Selected((int) game_info.result); 

	return true; 
}

String
Game_Info_Editor::Wdg_Init_Caption() 
	const
{
	return Trl("Game Information");
}

const Game_Info &
Game_Info_Editor::Editor_Window_Get_Value()
{
	if (Is())
		Retrieve_Value();
	return game_info; 
}

void
Game_Info_Editor::Set_Result(Game_Info::Result result)
{
	chooser.Set_Selected(result); 
}

void
Game_Info_Editor::Wdg_Close()
{
	Retrieve_Value();
	
	Object_Editor <Game_Info> ::Wdg_Close();
}

void Game_Info_Editor::Retrieve_Value()
{
	game_info.event= edits[0].Get_Text();
	game_info.site= edits[1].Get_Text();
	game_info.date= edits[2].Get_Text();
	game_info.round= edits[3].Get_Text();
	game_info.white= edits[4].Get_Text();
	game_info.black= edits[5].Get_Text();
	int result= chooser.Get_Selected(); 
	Assert (result != -1);
	game_info.result= (Game_Info::Result) result; 

}
