#ifndef GENERATE_LEGAL_INCLUDED
#define GENERATE_LEGAL_INCLUDED

/* Pseudo-legal moves are the legal moves plus those that put (or keep) the own
   king in check.   
*/

#include "position.hh"
#include "vector.hh"

enum {generator_max_leg= 262};

enum {gn_promotion= (1 << 0),};

void
Generate_Legal(Position &position, 
	       Vector <Move> &moves,
	       bool strict_legal,
	       bool just_check);

/* Generate legal moves in POSITION.

   Append moves to the array MOVE.  

   If STRICT_LEGAL is TRUE, only legal moves are generated.  If it is
   false, "pseudo-legal" moves are also generated.

   If JUST_CHECK is TRUE, just checks *whether* there are
   (pseudo-)legal moves, but don't generate any.  MOVES may still be
   used in this case.
*/

extern int gen_flags; 
/* Set by Generate_Legal().  Contains the gn_* flags. 
 */

#endif /* ! GENERATE_LEGAL_INCLUDED */
