#include "gtk_timer.hh"

#include "deref.hh"
#include "dbg.hh"
#include "timer.hh"

gint Gtk_Timer_Callback(gpointer data)
{
	Dbg_Function();

	Timer &timer= Deref((Timer *)data);
  
	timer.Timer_Alarm(); 

	return TRUE; 
}

bool Timer::Start(int interval_ms)
{
	Dbg_Function();
	Dbg("\tinterval= %d ms", interval_ms); 

	Assert (! Is());

	if (! content.Alloc())
		return false;

	content().id= gtk_timeout_add(interval_ms,
				      & Gtk_Timer_Callback,
				      this);

//  is= true; 

	return true;
}

void Timer::Stop()
{
	Dbg_Function(); 

	Assert (Is());

//	is= false;

	gtk_timeout_remove(content().id);

	content.Free(); 
}

Timer::Timer()
{
}

Timer::~Timer()
{
}
