#include "ics_account_stream.hh"

//#include "scan.hh"
#include "write_formatted.hh"
#include "parse_stream.hh"

bool
Read_Stream(Stream &stream,
	    ICS_Account &ics_account)
{
	char host[32 + 1];
	char user[32 + 1];
	char password[32 + 1];

	int port;
	
	int sf= Parse_Stream(stream,
			"%32[a-zA-Z0-9_-] @ %32[a-z.] : %d : %32s",
			user,
			host,
			& port,
			     password);

	if (sf != 4)
	  return false;

	ics_account.host= host;
	ics_account.user= user;
	ics_account.password= password;
	ics_account.port= port;

	return true;
}

bool
Write_Stream(Stream &stream,
	     const ICS_Account &ics_account)
{
	return Write_Formatted(stream,
			   "%s@%s:%d:%s\n",
			   ics_account.user(),
			   ics_account.host(),
			   ics_account.port,
			       ics_account.password());
}

