#include "ics_interaction_window.hh"

#include "trl.hh"

bool ICS_Interaction_Window::
Open(Pointer <Widget> parent,
     Pointer <Message_Receiver> new_owner,
     int new_msg_text)
{
  msg_text= new_msg_text; 

  if (! V_Packer::Open(parent))
    return false;

  V_Packer::Set_Next_Resizeable(true); 
  if (! ics_text.Open(this))
    goto close;

  if (! bottom_packer.Open(this))
    goto close;


  bottom_packer.Set_Next_Resizeable(true); 
  if (! edit.Open(bottom_packer,
		  Edit::Open_Info(Key::ret,
				  msg_edit)))
    goto close;
  if (! check_box.Open(bottom_packer,
			       true,
		       Trl("Append messages")))
    goto close;

  owner= new_owner;
  
  return true;

close:
  V_Packer::Close();
  return false;
}

String ICS_Interaction_Window::Pull_Text()
{
  String result= edit.Get_Text();
  edit.Set_Text("");
  return result;
}

void ICS_Interaction_Window::MR_Receive(int msg)
{
  if (msg == msg_edit)
    {
      owner().MR_Receive(msg_text); 
    }
  else
    V_Packer::MR_Receive(msg);
}

void ICS_Interaction_Window::Wdg_Close()
{
  owner= NULL; 
}

void ICS_Interaction_Window::Append_Message(String text)
{
  if (! check_box.Get_Checked())
    return;

  ics_text().Append_Text(text + '\n');

  ics_text().Scroll_End(); 
}

