#ifndef ICS_INTERACTION_WINDOW_INCLUDED
#define ICS_INTERACTION_WINDOW_INCLUDED

#include "packer.hh"
#include "edit.hh"
#include "check_box.hh"
#include "multi_edit.hh"
#include "scrolled.hh"

class ICS_Interaction_Window
:  public V_Packer
{
public:

  bool Open(Pointer <Widget> parent,
	    Pointer <Message_Receiver> owner,
	    int new_msg_text); /* when text is entered */ 

  String Pull_Text();

  void Append_Message(String text);

private:

  enum {msg_edit= V_Packer::msg_custom, msg_custom}; 

  H_Packer bottom_packer;
  Edit edit;
  Check_Box check_box;
  Scrolled <Multi_Edit>  ics_text; 

  int msg_text;

  Pointer <Message_Receiver> owner;

  void MR_Receive(int);
  void Wdg_Close(); 
  String Wdg_Init_Caption() const
    {
      return "ICS Messages"; 
    }
};

#endif /* ! ICS_INTERACTION_WINDOW_INCLUDED */ 
