#ifndef INFORMING_WINDOW_INCLUDED
#define INFORMING_WINDOW_INCLUDED

#include "inform_window.hh"

class Informing_Window
{
public:

	void Open(String title,
			 String text,
			 const Widget &transient_for)
		{
		  if (inform_window.Is())
		    {
		      inform_window().Close();
		      inform_window.Free();
		    }
		  if (! inform_window.Alloc())
		    return; 
			if (! inform_window().Open(NULL,
						   Inform_Window::Open_Info(title, text)))
			{
				inform_window.Free();
				return;
			}
		  inform_window().Set_Transient(transient_for); 
		}

	void Close()
		{
			if (! inform_window.Is())
				return;
			if (inform_window().Is())
				inform_window().Close();
			inform_window.Free(); 
		}
private:

	Dynamic <Inform_Window> inform_window; 
};

#endif /* ! INFORMING_WINDOW_INCLUDED */ 
