#include "int_edit.hh"

bool Int_Edit::
Open(Pointer <Widget> parent,
     Open_Info open_info)
{
	adjustment= GTK_ADJUSTMENT
		(gtk_adjustment_new
		 (open_info.value, 
		  open_info.min,
		  open_info.max, 
		  1, 100, 1000));

	if (adjustment == NULL)
		return false;

	if (! Widget::Open
	    (parent,
	     gtk_spin_button_new(adjustment, 1, 0)))
	{
		gtk_object_destroy(GTK_OBJECT(adjustment));
		return false;
	}
	msg_changed= open_info.msg_changed;

	gtk_signal_connect(GTK_OBJECT(Get()), 
			   "changed",
			   GTK_SIGNAL_FUNC(Signal_Changed), 
			   this);
			
	return true;
}

void Int_Edit::Signal_Changed(GtkEditable *editable,
			      gpointer data)
{
	Dbg_Function();

	Int_Edit *int_edit= (Int_Edit *)data;
	Assert (int_edit != NULL);
	Assert (Deref(int_edit).Get() ==
		GTK_WIDGET(editable));

	Deref(int_edit).MR_Send(Deref(int_edit).msg_changed);
}

void Int_Edit::Set_Value(int value)
{
	int save_msg_changed= msg_changed;
	gtk_spin_button_set_value
		(GTK_SPIN_BUTTON(Get()),
		 value); 
	msg_changed= save_msg_changed;
}

