#ifndef INT_EDIT_INCLUDED
#define INT_EDIT_INCLUDED

#include "widget.hh"

class Int_Edit
	:  public Widget 
{
public:

	struct Open_Info
	{
		int msg_changed;
		int min, max, value;

		Open_Info(int new_msg_changed= msg_ignore,
			  int new_value= 1,
			  int new_min= 0,
			  int new_max= 1000)
			:  msg_changed (new_msg_changed),
			   min (new_min),
			   max (new_max),
			   value (new_value)
			{
			}
	};

	int Get_Value() const
		{
			return gtk_spin_button_get_value_as_int
				(GTK_SPIN_BUTTON(Get()));
		}
	void Set_Value(int);
	bool Open(Pointer <Widget> parent,
		  Open_Info open_info);

private:

	GtkAdjustment *adjustment;
	int msg_changed;

	void Wdg_Close()
		{
			gtk_object_destroy(GTK_OBJECT(adjustment));
			Widget::Wdg_Close();
		}

	static void Signal_Changed(GtkEditable *editable,
				   gpointer user_data);
};

#endif /* ! INT_EDIT_INCLUDED */
