#ifndef IO_INCLUDED
#define IO_INCLUDED

/* IO::out, IO::err and IO::in are the standard streams.

   IO::dbg is additionally defined in debug mode, and is duplicated
   from IO::err.  However IO::dbg is never redirected as IO::err is. 

   To write to IO::dbg, the Debug() macro from the DEBUG is used. 
 */

#include "stream.hh"

#if ! defined (IO_NDEBUG) && defined (NDEBUG)
#    define IO_NDEBUG
#endif

#ifndef IO_NDEBUG
#     define IO_ENV "BABY_STDDBG"
#endif

class IO
{
private:

#ifndef IO_NDEBUG
	static class Main
	{
	public:
		
		Main();
	} main;
#endif

public:

	static Stream in, out, err;

#ifndef IO_NDEBUG
	static Stream dbg;
#endif
};

#endif /* ! STDIO_INCLUDED */


