#ifndef LEGAL_MOVE_LIST_INCLUDED
#define LEGAL_MOVE_LIST_INCLUDED

#include "multi_list_box.hh"
#include "generator.hh"
#include "notation.hh"
#include "framed.hh"
#include "trl.hh"
#include "packer.hh"
#include "text_widget.hh"

class Legal_Move_List
	:  public V_Packer
{
public:

	bool Open(Pointer <Widget> parent,
		  int msg_clicked= msg_ignore);

	void Set(const Generator &,
		 const Notation &);

	int Get_Selected() const
		{
			return move_list().Get_Selected(); 
		}
	void Clear()
		{
			move_list().Set_Row_Count(0);
			move_list.Set_Text(Trl("Legal moves"));
		}
private:

	enum {msg_list_clicked= Framed <Multi_List_Box> ::
	      msg_custom, msg_custom}; 

	int msg_clicked; 
	
	Framed <Multi_List_Box> move_list; 
	Text_Widget castlings_text, hm_text;

	void MR_Receive(int);
};

#endif /* ! LEGAL_MOVE_LIST_INCLUDED */
