#include "material_widget.hh"

#include "scaled_board_image.hh"
#include "style.hh"

void
Material_Widget::Image_Widget_Build(Server_Image &image)
{
	Assert (Is());

#if 0
	/* Count pieces. 
	 */
	int count[6][2];
	for (int cc= 0;  cc < 2;  ++cc)
		for (int pt= 0;  pt < 6;  ++pt)
			count[pt][cc]= 0;
	for (int file= sq_a;  file <= sq_h;  ++file)
		for (int rank= sq_1;  rank <= sq_8;  ++rank)
		{
			Piece piece= position.Get_Piece(Make_Square(file, rank));
			if (piece.Is())
			{
				++ count[piece.Get_Type()][piece.Get_Color()];
			}
		}
#endif /* 0 */ 

	int count[6][2];
	/* count of piece that will be displayed. */ 
			
	for (int pt= 0;  pt < 6;  ++pt)
	{
		int smallest= position.Get_Material(pt, 0) <?
			position.Get_Material(pt, 1);
		count[pt][0]= position.Get_Material(pt, 0) - smallest;
		count[pt][1]= position.Get_Material(pt, 1) - smallest;
	}

	int number[2];
	/* number of displayed pieces by color */ 

	for (int cc= 0;  cc < 2;  ++cc)
	{
		number[cc]= 0;
		for (int pt= 0;  pt < 6;  ++pt)
			number[cc] += count[pt][cc];
	}

	/* Open image with new size. 
	 */

	image.Free();

	if (number[0] == 0 && number[1] == 0)
		/* Don't open 0 x 0 image. 
		 */
		return;

	int max_length= 10; /* max number of pieces on one line */ 

	Point dimension= Point((number[0] >? number[1]) <? max_length,
			       ((number[0] + max_length - 1) / max_length >? 1)  +
			       ((number[1] + max_length - 1) / max_length >? 1));
	/* in small square units */ 

	if (! image.Create(width * dimension))
		return;
	if (! image.Has_Canvas())
		return;

	/* Draw pieces. 
	 */
	image().Set_Color(Style_Color(st_face));
	image().Draw_Rect(width * dimension);
	Scaled_Board_Image sbi;
	if (! sbi.Load(width, true))
		return;
	
	int line= 0;
	for (int cc= 0;  cc < 2;  ++cc)
	{
		int index= 0;
		int dc= turned ? cc : CC_Turn(cc);
		for (int pt= 5;  pt >= 0;  --pt)
		{
			for (int i= 0;  i < count[pt][dc];  ++i)
			{
				if (index == max_length)
				{
					index= 0;
					++ line;
				}
				sbi.Draw(image(),
					 width * Point(index, line),
					 pt,
					 (Chess_Color)dc);
				++index;
			}
		}
		++ line;
	}
}

void Material_Widget::Image_Widget_Get_Dimension(int &new_width,
						 int &new_height)
{
	new_width= 0;
	new_height= 2 * width;
}

bool Material_Widget::Get_Show(const Position &position)
{
		
#if 0
	int count[6][2];
	for (int cc= 0;  cc < 2;  ++cc)
		for (int pt= 0;  pt < 6;  ++pt)
			count[pt][cc]= 0;
	for (int file= sq_a;  file <= sq_h;  ++file)
		for (int rank= sq_1;  rank <= sq_8;  ++rank)
		{
			Piece piece= position.Get_Piece(Make_Square(file, rank));
			if (piece.Is())
			{
				++ count[piece.Get_Type()][piece.Get_Color()];
			}
		}
#endif /* 0 */ 

	for (int i= 0;  i < 6;  ++i)
		if (position.Get_Material(i, 0) != position.Get_Material(i, 1))
			return true;
	return false;
}

void Material_Widget::Set(const Position &new_position,
			  bool new_turned)
{
	position= new_position;
	turned= new_turned; 
	Invalidate_Image();
}
