#include "notation_editor.hh"

const Notation &Notation_Editor::Editor_Window_Get_Value()
{
	if (Is())  Retrieve_Value();
	return notation; 
}

bool Notation_Editor::Object_Editor_Open(Pointer <Widget> parent)
{
	for (int i= 0;  i < 8;  ++i)
	{
		const char *text[8]= {"Short",
				      "Pawn sign",
				      "En passant",
				      "Check / Checkmate / Stalemate",
				      "Capture sign in short notation",
				      "Capture sign at the end in short notation",
				      "Pawn capture sign in short notation",
				      "Captured piece"};
		if (! check_box[i].Open(parent,
					notation.Get_Options() & (1 << i),
					Trl(text[i])))
			return false; 
	}
	return true; 
}

void Notation_Editor::Editor_Window_Set_Value(Pointer <const Notation> new_notation)
{
	if (new_notation.Is())
		notation= new_notation();
	else
		notation= san_notation; 
}

bool Notation_Editor::Editor_Window_New()
{
	notation= san_notation;
	for (int i= 0;  i < 8;  ++i)
		check_box[i].Set_Checked(notation.Get_Options() & (1 << i)); 
	return true; 
}

void Notation_Editor::Wdg_Close()
{
	Retrieve_Value();
	Object_Editor <Notation> ::Wdg_Close();
}

void Notation_Editor::Retrieve_Value()
{
	int options= notation.Get_Options(); 
	for (int i= 0;  i < 8;  ++i)
	{
		options &= ~(1 << i);
		if (check_box[i].Is() &&
		    check_box[i].Get_Checked())
			options |= (1 << i);
	}
	notation.Set_Options(options); 
}
