#include "object.hh"

#ifndef OBJECT_NDEBUG

#include "io.hh"

#ifdef OBJECT_DBG
#include "debug.hh"
#endif

int object_count= 0;
/* Number of objects. 
 */

#ifdef OBJECT_DBG
void
Object_On_Construction(const char *_type,
		       void *_pointer)
#else
void
Object_On_Construction(const char *, void *)
#endif
{
	++ object_count;

#ifdef OBJECT_DBG
	Debug(		    "Constructor(%12s, %12p)  [%4d]",
		    _type,
		    _pointer,
			    object_count);
#endif	
}

#ifdef OBJECT_DBG
void 
Object_On_Destruction(const char *_type,
		      void *_pointer)
#else
void
Object_On_Destruction(const char *, void *)
#endif
{
	Assert (object_count > 0);

	-- object_count;
	
#ifdef OBJECT_DBG
	Debug(
		    "  Destructor(%12s, %12p)  [%4d]",
		    _type,
		    _pointer,
		    object_count);
#endif
}

#endif /* ! NDEBUG */
