#ifndef OBJECT_INCLUDED
#define OBJECT_INCLUDED

/* Explicit call of constructor/destructor. 
 */

#include <stdlib.h>
#include <new>

#if defined (NDEBUG) && ! defined (OBJECT_NDEBUG)
#define OBJECT_NDEBUG
#endif

#ifdef OBJECT_NDEBUG

#define Constructor(type, pointer, args...)    \
        new (pointer) type(args)
#define Destructor(type, pointer)              \
        (pointer)->~type()

#else /* ! OBJECT_NDEBUG */

void
Object_On_Construction(const char *_type,
		       void *_pointer);
void 
Object_On_Destruction(const char *_type,
		      void *_pointer);

#define Constructor(type, pointer, args...)   		\
        (						\
		new (pointer) type(args),		\
		Object_On_Construction(#type, pointer)	\
	)

#define Destructor(type, pointer)              		\
        (						\
		(pointer)->~type(),			\
		Object_On_Destruction(#type, pointer)	\
	)

#endif /* ! OBJECT_NDEBUG */

#endif /* ! OBJECT_INCLUDED */
