#ifndef OBJECT_EDITOR_INCLUDED
#define OBJECT_EDITOR_INCLUDED

/* A window that edits an object.  The window is always owned by another window.  
 */

#include "editor_window.hh"
#include "button_bar.hh"
#include "bevel.hh"

template <class Type>
class Object_Editor
	:  public Editor_Window <Type> 
{
public:

	virtual bool Object_Editor_Open(Pointer <Widget> parent)= 0; 

private:

	Bevel bevel;
	H_Button_Bar button_bar;

	bool Editor_Window_Open(Pointer <Packer> parent)
		{
			if (! Object_Editor_Open(parent()))
				return false; 

			bevel.Open(parent());

			if (button_bar.Open(parent()))
			{
				button_bar.Append_OK_Button();
				button_bar.Append_Reset_Button(); 
				button_bar.Append_Apply_Button();
				button_bar.Append_Cancel_Button();
			}
			return true; 
		}

	Point Wdg_Get_Window_Size() const
		/* Return x=-1 for no resizing. 
		 */
		{
			return Point(-1);
		}
}; 

#endif /* ! OBJECT_EDITOR_INCLUDED */ 
