#ifndef PACKER_INCLUDED
#define PACKER_INCLUDED

#include "widget.hh"

class Packer
	:  /*virtual*/ public Widget
{
public:

	typedef int Open_Info; /* spacing */ 

//	struct Open_Info {}; 

	bool Open(Pointer <Widget> parent,
		  Open_Info spacing= 0)
		{
			GtkWidget *gtkwidget= Packer_Open();
			
			if (gtkwidget == NULL)
				return false;

			gtk_widget_set_usize(gtkwidget, -1, -1);

			if (! Widget::Open(parent, gtkwidget)) 
				return false;

			use_next= false;
			
			if (spacing)
				gtk_box_set_spacing(GTK_BOX(Get()),
						    spacing); 

			return true;
		}

	void Set_Next_Resizeable(bool resizeable)
		{
			use_next= true;
			next_resizeable= resizeable;
		}

private:

	bool next_resizeable;
	bool use_next;

	void Wdg_Append_Child(Widget &widget)
		{
			if (! use_next)
			{
				next_resizeable= false;
				int w, h;
				widget.Wdg_Get_Size_Request(w, h,
							    next_resizeable); 
			}
			else
				use_next= false;

			gboolean arg= next_resizeable ? TRUE : FALSE;

			gtk_box_pack_start(GTK_BOX(Get()),
					   widget.Get(),
					   arg,
					   arg,
					   0);
		}
	void Wdg_Get_Size_Request(int & /* width */ ,
				  int & /* height */ ,
				  bool &resizeable);
	virtual GtkWidget *Packer_Open() const
		{
			return NULL; 
		}
};

class V_Packer
	:  public Packer
{
private:

	GtkWidget *Packer_Open() const
		{
			return gtk_vbox_new(FALSE, 0);
		}
};

class H_Packer
	:  public Packer
{
private:

	GtkWidget *Packer_Open() const
		{
			return gtk_hbox_new(FALSE, 0); 			
		}
};

#endif /* ! PACKER_INCLUDED */
