#ifndef PNG_INCLUDED
#define PNG_INCLUDED

/* Portable Network Graphics. 

   See RFC 2083 <ftp://ftp.uu.net/graphics/png/documents/>. 
 */

/* To be replaced by gdk-pixbuf. 
 */

#include "client_image.hh"
#include "stream.hh"

class PNG
{
public:

	static bool Write(Stream              &stream,
			  const Client_Image &image,
			  bool                interlaced= false);
	/* Write PNG representation of IMAGE into FILE.  Return TRUE
	   on success. 
	 */

	static bool Read(Stream                 &stream,
			 Client_Image           &image,
			 Pointer <Client_Image>  alpha= NULL);
	/* Read from file.  Put alpha channel into ALPHA when not
	   NULL.  Draw alpha channel as black=transparent and
	   white=opaque. 
	 */
};

#endif /* ! PNG_INCLUDED */
