#include "poll.hh"

#include "deref.hh"
#include "time.hh"
#include "dbg.hh"

bool
Poll(Stream_Set &stream_set,
     Time *time)
{
	Dbg_Function();

#ifndef TIME_NEW
	struct timeval *timeval= NULL; 
	struct timeval stimeval;
	if (time != NULL)
	{
		stimeval.tv_sec= Deref(time) / CLOCKS_PER_SEC;
		stimeval.tv_usec= Deref(time) % CLOCKS_PER_SEC * 1000000 / CLOCKS_PER_SEC; 
		timeval= &stimeval; 
	}
#else /* TIME_NEW */
	Time *timeval= time;
#endif /* TIME_NEW */ 

	int result= select(FD_SETSIZE,
			   & stream_set.Get_Set(),
			   NULL,
			   NULL,
			   timeval); 

	Dbg_Int(result);

	return result != -1;
}

