#ifndef RESOLVE_PATH_INCLUDED
#define RESOLVE_PATH_INCLUDED

/* Resolve `.', `..' and symlinks in filenames.  Don't resolve `~'. 
 */

#include "resolve_path.config.hh"

#if defined (RESOLVE_PATH_RESOLVEPATH) || defined (RESOLVE_PATH_REALPATH)

#include "string.hh"

#include <limits.h>
#include <stdlib.h>

#ifdef RESOLVE_PATH_RESOLVEPATH
#   include <unistd.h>
#endif

Inline
String
Resolve_Path(String file)
{
#ifdef RESOLVE_PATH_RESOLVEPATH

	char buf[PATH_MAX + 1];
	
	int r= resolvepath(file(),
				 buf,
				 PATH_MAX);

	if (r == -1)
		return file;

	buf[r]= '\0';

#else /* RESOLVE_PATH_REALPATH */

	char buf[PATH_MAX];
	if (NULL == realpath(file(), buf))
		return file;
	return buf;

#endif /* RESOLVE_PATH_REALPATH */
	
	return buf;
}

#else /* ! RESOLVE_PATH_* */

#include "file_name.hh"

Inline
String
Resolve_Path(String file)
{
	return Glob_File_Name(file);
}

#endif /* ! RESOLVE_PATH_NAME */

#endif /* ! RESOLVE_PATH_INCLUDED */
