#include "server_image_stream.hh"

bool
Write_Stream(Stream &file, 
	     const Server_Image &server_image)
{
	Assert (server_image.Is());

	if (! server_image.Has_Canvas())
		return false;
//	Canvas ca;

	Client_Image client_image;
	if (! client_image.Receive_Rect(server_image(), 
			     Rect(Point(0),
				  server_image.Get_Size())))
		return false;

	return Write_Stream(file,
			  client_image);
}

bool
Read_Stream(Stream &stream,
	    Server_Image &server_image)
{
	Client_Image client_image;

	if (! Read_Stream(stream,
			client_image))
		return false;

	if (! server_image.Create(client_image.Get_Size()))
		return false;

	if (! server_image.Has_Canvas())
		return false;

	client_image.Send_Rect(server_image.Get_Canvas(),
			       Rect(client_image.Get_Size()),
			       Point(0));

	return true;
}
