#ifndef STAT_INCLUDED
#define STAT_INCLUDED

#include "date.hh"
#include "stream.hh"

enum Type {stat_dir,
	   stat_regular,
	   stat_pipe, stat_link,
	   stat_block,
	   stat_character, stat_socket};

class Perm
{
public:
    
	int user, group, other;
};

class Stat
{
public:

	Type type;
	int size;
	Perm perm;
	Date a_date, m_date, c_date;
};

bool Get_Stat(const Stream &, Stat &) ; 

bool Get_Stat(String, Stat &, bool= true);

bool Make_Stat(Stat &stat, 
	       struct stat &s);
/* Convert S to STAT and return TRUE on success. 
 */

#endif /* ! STAT_INCLUDED */
