#ifndef STREAM_SET_INCLUDED
#define STREAM_SET_INCLUDED

#include "stream.hh"
#include "vector.hh"

class Stream_Set
{
public:

	Stream_Set()
		{
			FD_ZERO ( & set); 
		}

	fd_set &Get_Set()
		{
			return set; 
		}

	bool Insert(const Stream &stream)
		{
			Assert (stream.Has_FD()); 
			FD_SET(stream.Get_FD(), & set);

			return true; 
		}
	void Remove(const Stream &stream)
		{
			FD_CLR(stream.Get_FD(), & set); 
		}

	bool Ready(const Stream &stream) const
		{
			return FD_ISSET(stream.Get_FD(), & set); 
		}

private:

	fd_set set; 
};

#endif /* ! STREAM_SET_INCLUDED */ 
