#include "gui_main.hh"
#include "program_window.hh" 
#include "board.hh"
#include "text_widget.hh"
#include "stream_file.hh"
#include "server_image_stream.hh"
#include "board_image.hh"

class Main_Window
	:  public V_Packer,
	   public Program_Window
{
public:

	typedef Program_Window::Open_Info Open_Info; 

	bool Open(Pointer <Widget> parent,
		  Open_Info)
		{
			position.Reset();
			if (! V_Packer::Open(parent))
				return false;
			board.Open(this,
				   Board::Open_Info(position));
			text_widget.Open(this, "Board"); 

			return true; 
		      }

	static String Get_Help()
		{
			return "Board.\n"; 
		}

private:

	Position position; 

	Board board;
	Text_Widget text_widget; 
};

GUI_MAIN(Main_Window)
