#include "main.hh"
#include "game.hh"
#include "game_stream.hh"
#include "stream_file.hh"
#include "exit.hh"
#include "write_formatted.hh"
#include "io.hh"
#include "error.hh"

void
Do_Error()
{
	Write_Formatted(IO::err,
			"*** %s\n",
			Error::Get()());
	Exit(1);
}

int Main(int argc, 
	 char **argv)
{
	Assert (argc == 3);

	Game game;

	if (! Read_From_File(argv[1], game))
		Do_Error();

	if (! Write_To_File(argv[2], game))
		Do_Error();

	return 0;
}
