#include "tool_bar.hh"

#include "dbg.hh"

void
Tool_Bar::Append(Glyph_Type type,
	      int msg,
	      String tooltip)
{
	Dbg_Function();
	Dbg("\tthis= %p", this);
	Dbg("\ttooltip= \"%s\"", tooltip()); 

	const char *text;

	switch (type)
	{
	case gl_nothing: 
	default:          text= ".";   break;
	case gl_up:       text= "^";   break;
	case gl_down:     text= "v";   break;
	case gl_left:     text= "<";   break;
	case gl_right:    text= ">";   break;
	case gl_check:    text= "x"; break;
	case gl_start:    text= "|<";  break;
	case gl_back:     text= "<<";  break;
	case gl_forward:  text= ">>";  break;
	case gl_end:      text= ">|";  break;
	case gl_stop:     text= "(X)"; break;
//	case gl_clear:    text= "[X]"; break;
	case gl_apply:    text= ">o";  break;
	case gl_new:      text= "N";   break;
	case gl_run:      text= "|>";  break;
	case gl_radio:    text= "o";   break;
	case gl_copy:     text= "C";   break;
	case gl_paste:    text= "P";   break; 
	case gl_pause:    text= "||";  break; 
	}

	if (! callbacks.Set(*callbacks + 1))
		return; 

	if (! callbacks[-1].Alloc(this, msg))
	{
		callbacks= -1;
		return;
	}

	Callback *callback= & callbacks[-1]();
	Dbg("\tcallback= %p", callback);

	gtk_toolbar_append_item
		(GTK_TOOLBAR(Get()),
		 text,  
		 tooltip(),	
		 "private-help",
		 NULL,
		 (GtkSignalFunc) & Callback::Call,
		 callback);
}

gint
Tool_Bar::Callback::Call(GtkWidget *,
			 gpointer data)
{
	Dbg_Function();
	Dbg("\tdata= %p", data);

	Assert (data != NULL);

	Callback &callback= *(Callback *)data;
	Dbg("\ttool_bar= %p", & callback.tool_bar()); 
	callback.tool_bar().MR_Send(callback.msg);

	return TRUE;
}
#if 0
void Tool_Bar::
Wdg_Add_Child(Widget &widget)
{
	if (! callbacks.Set(*callbacks + 1))
	{
		return; 
	}

	if (! callbacks[-1].Alloc(this, msg))
	{
		callbacks= -1;
		return;
	}

	Callback *callback= & callbacks[-1]();
	gtk_toolbar_append_element
		(GTK_TOOLBAR(Get()),
		 GTK_TOOLBAR_CHILD_WIDGET,
		 widget.Get(),
		 "item",  
		 "tooltip",
		 "private-help",
		 NULL,
		 (GtkSignalFunc) & Callback::Call,
		 callback);
}

#endif/* 0 */
